######################################################################
# sitemap.pl - This is PyukiWiki, yet another Wiki clone.
# sitemap plugin
#
# $Id: sitemap.inc.pl,v 1.1.1.1 2006/01/07 15:36:28 papu Exp $
#
# Copyright (C) 2004 by Nekyo.
# Copyright (C) 2006 PyukiWiki Developers Team
# License: GPL v2 or (at your option) any later version
# http://nekyo.hp.infoseek.co.jp/
# http://pyukiwiki.sourceforge.jp/
#
# Based on YukiWiki <hyuki@hyuki.com> http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
#
# 1TAB=4Spaces
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:UNIX=LF/Windows=CR+LF/Mac=CR
# Japanese Code=EUC
######################################################################
# MenuBarǤϰʲΤ褦˵Ҥ
# [[WikiName]]
# [[ڡ]]
# (WikiNameǤưޤ)
#
# MenuBarϿ줿ڡǤϡʲΤ褦˵Ҥ
# -[[WikiName]]
# -[[ڡ]]~
# -[[?cmd=ץ饰&.....]]~
#
# p.s. [[>http://www.yahoo.co.jp/]] 󥯤ϤϤޤ
#
# Ȥ
# ?cmd=sitemap
# http://lineage.netgamers.jp/?cmd=sitemap
# resource.ja.txt  sitemap=ȥޥåסɲä롣
#
# ܤwikiΥߤƤ
# http://lineage.netgamers.jp/?cmd=adminedit&mypage=MenuBar
# http://lineage.netgamers.jp/?cmd=adminedit&mypage=%bd%d0%b2%d4%a4%ae%a5%ea%a5%b9%a5%c8
# http://lineage.netgamers.jp/?cmd=edit&mypage=%bd%d0%b2%d4%a4%aeFPK%b9%b6%ce%ac
######################################################################


sub plugin_sitemap_action {
	my $prev = '';
	my $char = '';
	my $idx = 1;
	my $menubar=$::MenuBar;
	my $name;
	my $menucount=0;
	my $submenucount=0;
	my $menu;
	my $basepage;
	my $nextpage;
	my $body="*$::resource{sitemap}\n";

	foreach $basepage(split(/\n/,$::database{$menubar})) {
		if($basepage=~/^\*\*\*/) {
			$name=$basepage;
			$name=~s/^\*\*\*//g;
			$name=~s/\~//g;
			$menucount++;
			push(@sitemap,$name);
		}elsif($basepage=~/^\[\[/ && $basepage!~/>(http:|https:|ftp:|mailto:|\?)/) {
			$basepage=~s/(\[\[|\]\])//g;
			$basepage=~s/\~//g;
			$basepage=~s/.*>//g if($basepage=~/>/);
			$basepage=~s/\s//g;
			if($::session{'view_level'}+0 >= &get_info($basepage , $::info_Level)+0) {
				$submenucount++;
				$sitemap{$name}.=sprintf("%05d\t%05d\t%05d\t%s\n",$menucount,$submenucount,0,$basepage);
				$nextmenucount=0;
				foreach $subpage(split(/\n/,$::database{$basepage})) {
					if($subpage =~ /^-\[\[(.*?)\]\]/ && $subpage!~/>(http:|https:|ftp:|mailto:|\?)/
					|| $subpage=~/>\?cmd=.*/ && $subpage =~ /^-\[\[(.*?)\]\]/
							) {
						$nextpage=$1;
						$nextpage=~s/(\[\[|\]\])//g;
						$nextpage=~s/\~//g;
						$nextpage=~s/.*>//g if($nextpage=~/>/ && $nextpage !~/\?cmd=/);
						$nextpage=~s/\s//g;
						if($::session{'view_level'}+0 >= &get_info($nextpage , $::info_Level)+0) {
							$nextmenucount++;
							$sitemap{$name}.=sprintf("%05d\t%05d\t%05d\t%s\n",$menucount,$submenucount,$nextmenucount,$nextpage);
						}
					}
				}
			}
		}
	}
	foreach $menu(@sitemap) {
		if($sitemap{$menu} ne '') {
			$body.="-''$menu''\n";
			foreach(split(/\n/,$sitemap{$menu})) {
				($menucount,$submenucount,$nextmenucount,$page)=split(/\t/,$_);
				$page=~s/\s//g;
				if($nextmenucount+0 eq 0) {
					$body.="--[[$page]]\n";
				} else {
					$body.="---[[$page]]\n";
				}
			}
		}
	}
	$body=&text_to_html($body,0);

	return ('msg' => $::resource{sitemap}, 'body' => $body);
}
1;
