######################################################################
# pyukiwiki.ini.cgi - This is PyukiWiki, yet another Wiki clone.
#
# $Id$
#
# Copyright (C) 2004 by Nekyo.
# Copyright (C) 2006 PyukiWiki Developers Team
# License: GPL v2 or (at your option) any later version
# http://nekyo.hp.infoseek.co.jp/
# http://pyukiwiki.sourceforge.jp/
#
# Based on YukiWiki <hyuki@hyuki.com> http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
#
# 1TAB=4Spaces
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:UNIX=LF/Windows=CR+LF/Mac=CR
# Japanese Code=EUC
######################################################################

use strict;

# 
$::lang = "ja";				# ja:ܸ/cn:()/en:Ѹ()
$::kanjicode = "euc";		# euc:EUC-JP/utf8:UTF-8

# ǡǼǥ쥯ȥ
$::data_home = '.';		# CGIΤߥǡΥǥ쥯ȥ
$::data_pub = '.';		# ֥饦鸫ǡΥǥ쥯ȥ
$::data_url = '.';		# ֥饦СХǥ쥯ȥ

# cgi-bin̤Υǥ쥯ȥ
# for sourceforge.jp
# /home/groups/p/py/pyukiwiki/htdocs
# /home/groups/p/py/pyukiwiki/cgi-bin
#$::data_home = '.';		# CGIΤߥǡΥǥ쥯ȥ
#$::data_pub = '../htdocs';	# ֥饦鸫ǡΥǥ쥯ȥ
#$::data_url = '..';		# ֥饦СХǥ쥯ȥ

$::data_dir    = "$::data_home/wiki";		# ڡǡ¸
$::diff_dir    = "$::data_home/diff";		# ʬ¸
$::cache_dir   = "$::data_pub/cache";		# 
$::cache_url   = "$::data_url/cache";		# 
$::upload_dir  = "$::data_pub/attach";		# ź
$::upload_url  = "$::data_url/attach";		# źURL
$::counter_dir = "$::data_home/counter";	# 
$::plugin_dir  = "$::data_home/plugin";		# ץ饰
$::skin_dir    = "$::data_pub/skin";		# 
$::skin_url    = "$::data_url/skin";		# URL
$::image_dir   = "$::data_pub/image";		# 
$::image_url   = "$::data_url/image";		# URL
$::info_dir    = "$::data_home/info";		# 
$::res_dir     = "$::data_home/resource";	# ꥽

# ե
$::skin_file   = "$::skin_dir/pyukiwiki.skin." . $::lang . ".cgi";
$::use_blosxom=0;	# blosxom.cssѤȤˤ

# ưŪåȥåץե
$::setup_file	= "$::info_dir/setup.ini.cgi";

# Ծ
$::modifier = 'PyukiWiki Developers Team';				# ̾
$::modifierlink = 'http://pyukiwiki.sourceforge.jp/';	# URI
$::modifier_mail = '';									# ԥ᡼륢ɥ쥹

# ǥեȥڡ̾
#$::script			= 'index.cgi';
$::script			= '';								# ư

$::FrontPage		= 'FrontPage';
$::RecentChanges	= 'RecentChanges';
$::CreatePage		= 'CreatePage';
$::IndexPage		= 'IndexPage';
$::MenuBar			= 'MenuBar';
$::Header			= ':Header';
$::Footer			= ':Footer';
$::rule_page		= "롼";

$::adminpass = crypt("pass", "AA");

# RSS
$::modifier_rss_title = "PyukiWiki $::version";
$::modifier_rss_link = 'http://pyukiwiki.sourceforge.jp/';
$::modifier_rss_description = 'This is PyukiWiki.';

# ɽ
$::usefacemark = 1;		# եޡ 1:Ȥ/0:Ȥʤ
$::use_popup = 1;   	#  1:ݥåץå/0:ڡ
$::last_modified = 2;	# ǽ 0:ɽ/1:ɽ/2:ɽ
$::lastmod_prompt = 'Last-modified:'; # ǽΥץץ
$::allview = 1;			# 1:٤Ƥβ̤Header, MenuBar, Footerɽ, 0:ʤ

$::enable_convtime = 1;	# Сȥ 1:ɽ/0:ɽ;

# եޥå
$::date_format = 'Y-m-d'; # replace &date; to this format.
$::time_format = 'H:i:s'; # replace &time; to this format,

# ڡԽ
$::cols = 80;			# ƥȥꥢΥ
$::rows = 25;			# ƥȥꥢιԿ
$::extend_edit = 1;		# ĥǽ(JavaScript) 1:/0:̤
$::pukilike_edit = 1;	# PukiWiki饤Խ 1:Pukiwiki/0:Pyukiwiki

# ᡼륢ɥ쥹αòʤ϶ʸ󡢤ϰŹ沽뤿Υ
$::AntiSpam="Tfj8a9xNoLkm2Z43";
#$::AntiSpam="";

# ź
$::file_uploads = 1;	# źդ 0:Ȥʤ/1:Ȥ/2:ǧդ/3:Τǧ
$::max_filesize = 100000;	# åץɥե

# 
$::use_FuzzySearch=1;	# 0:̾︡/1:ܸ줢ޤѤ

# ȥޥå
$::use_SiteMap=1;		# 0:ListΤ/1:List,ȥޥåξ

#
$::_symbol_anchor = '&dagger;';
$::maxrecent = 50;

# ˴ޤʤڡ̾(ɽ)
$::non_list = '^\:';

# Skin  gzip ѥꤹȰ̤ͭˤʤ롣
$::gzip_path = '/bin/gzip -1';
$::gzip_path = '/usr/bin/gzip -1';
$::gzip_path = '';

# P3PΥѥȥݥꥷ http://fs.pics.enc.or.jp/p3pwiz/p3p_ja.html
# ɬפǤ /w3cʲǥ쥯ȥˤŬڤ˥ե֤ͭˤޤ
#$::P3P="NON DSP COR CURa ADMa DEVa IVAa IVDa OUR SAMa PUBa IND ONL UNI COM NAV INT CNT STA";
$::P3P="";

1;
