######################################################################
# urlhack.inc.pl - This is PyukiWiki, yet another Wiki clone.
# urlhack Plugin
#
# $Id: urlhack.inc.pl,v 1.5 2006/01/09 03:22:32 papu Exp $
#
# PyukiWiki Version 0.1.5a5-pre1
# Copyright (C) 2004 by Nekyo.
# Copyright (C) 2006 PyukiWiki Developers Team
# License: GPL v2 or (at your option) any later version
# http://nekyo.hp.infoseek.co.jp/
# http://pyukiwiki.sourceforge.jp/
#
# Based on YukiWiki <hyuki@hyuki.com> http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
#
# 1TAB=4Spaces
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:UNIX=LF/Windows=CR+LF/Mac=CR
# Japanese Code=EUC
######################################################################
# This is extented plugin.
# To use this plugin, rename to 'urlhack.inc.cgi'
######################################################################
#
# SEOкURLϥåץ饰
#
# Ȥ
#
# URL.wiki.cgi / ǽäƤʤ
#   urlhack.inc.plurlhack.inc.cgi˥͡हǻȤޤ
#
# URL / ǽäƤ (nph CGIǤʤưޤ)
#   wikiindex.cgi nph-index.cgi˥͡षư뤳Ȥ
#     ǧޤ
#   .htaccessΥץˤ
#      #ErrorDocument 400 /index.cgi?cmd=servererror
#      ͭˤŬڤʥե̾ (/nph-index.cgi?cmd=servererror)
#      ѹޤ
#   θ塢.htaccess DirectoryIndex ΰֺǽ
#      nph-index.cgi äޤ
#
# ¾
#   $fake_extention
#     γĥҤꤷޤʤƤ
#   $noconvet_alphanum
#     ѿ̾ǹ줿ڡ̾ϡѴ˽Ϥޤ
#     (Ʊ̾Υե̾Υǥ쥯ȥ¸ߤȡ餬ͥ)
#
######################################################################

# fake extension
$fake_extention=".html";	# or null

# not convert Alphabet or Number 's pages
$noconvert_alphanum=1;		# 0:NO / 1:YES

# Initlize

sub plugin_urlhack_init {
	unless($ENV{SCRIPT_NAME}=~/nph-/ || $ENV{REQUEST_URI}=~/\.cgi/) {
		return;
	}
	my $req;
	if($::form{cmd} eq 'servererror') {
		if($ENV{REDIRECT_STATUS} eq 404) {
			$req=$ENV{REDIRECT_URL};
		} else {
			return;
		}
	}
	if($req ne '' || $::form{cmd} eq '' || $::form{cmd} eq 'read') {
		$req=$ENV{REQUEST_URI};
	} else {
		return;
	}
	$req=~s/.*\///g;
	$req=~s/\..*//g;
	if($noconvert_alphanum+0 eq 1) {
		if(&is_exist_page($req)) {
			$::form{cmd}='read';
			$::form{mypage}=$req;
			return;
		}
	}
	$req=~s/([A-Fa-f0-9][A-Fa-f0-9])/pack("C", hex($1))/eg;
	if($req eq '') {
		$::form{cmd}='read';
		$::form{mypage}=$::FrontPage;
		return;
	} elsif(&is_exist_page($req)) {
		$::form{cmd}='read';
		$::form{mypage}=$req;
	} else {
		$req=&decode($ENV{QUERY_STRING});
		if(&is_exist_page($req)) {
			$::form{cmd}='read';
			$::form{mypage}=$req;
		} else {
			$::form{cmd}='servererror';
			$ENV{REDIRECT_STATUS}=404;
			$ENV{REDIRECT_URL}=$ENV{REQUEST_URI};
			$ENV{REDIRECT_REQUEST_METHOD}="GET";
		}
	}
}

# hack wiki.cgi of make_cookedurl

sub make_cookedurl {
	my($cookedchunk)=@_;
	unless($ENV{SCRIPT_NAME}=~/nph-/ || $ENV{REQUEST_URI}=~/\.cgi/) {
		return("$::script?$cookedchunk");
	} else {
		$cookedchunk=&decode($cookedchunk);
		if($cookedchunk=~/(\W)/ || $noconvert_alphanum+0 eq 0) {
			$cookedchunk=~ s/(.)/unpack('H2', $1)/eg;
		}
		my $script=$::script;
		$script=~s/\/$//g;
		return "$script/$cookedchunk$fake_extention";
	}
}

1;
