######################################################################
# article.inc.pl - This is PyukiWiki, yet another Wiki clone.
# PyukiWiki BBS Plugin
# Based on OKAWARA,Satoshi's PukiWiki Plugin
#
# $Id: article.inc.pl,v 1.6 2006/01/10 15:23:41 papu Exp $
#
# PyukiWiki Version 0.1.5a5-pre1
# Copyright (C) 2004 by Nekyo.
# Copyright (C) 2006 PyukiWiki Developers Team
# License: GPL v2 or (at your option) any later version
# http://nekyo.hp.infoseek.co.jp/
# http://pyukiwiki.sourceforge.jp/
#
# Based on YukiWiki <hyuki@hyuki.com> http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
#
# 1TAB=4Spaces
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:UNIX=LF/Windows=CR+LF/Mac=CR
# Japanese Code=EUC
######################################################################

use strict;

$article::cols = 70;								# ƥȥꥢΥ
$article::rows = 5;									# ƥȥꥢιԿ
$article::name_cols = 24;							# ̾ƥȥꥢΥ
$article::subject_cols = 60;						# ̾ƥȥꥢΥ
$article::name_format = $::resource{name_format};	# ̾եޥå
$article::subject_format = '**$subject';			# ̾եޥå
$article::ins = 0;									#  1: 0:θ
$article::comment = 1;								# ߲˰ԥȤ 1: 0:ʤ
$article::auto_br = 1;								# ԤưŪѴ 1: 0:ʤ
$article::noname = 0;								# ̾ʤǽʤ
$article::nosubject = 0;							# ֥Ȥʤǽʤ
$article::no = 0;

my $_no_name = "";
my $_no_subject = "no subject";

sub plugin_article_action {
	if (($::form{msg} =~ /^\s*$/)
	 || ($::form{name} =~ /^\s*$/ && $article::noname eq 1)
	 || ($::form{subject} =~ /^\s*$/ && $article::nosubject eq 1)) {
		return('msg'=>"$::form{mypage}\t\t$::resource{article_plugin_err}",'body'=>&text_to_html($::database{$::form{mypage}}),'ispage'=>1);
	}
	my $name = $_no_name;
	if ($::form{name} ne '') {
		$name = $article::name_format;
		$name =~ s/\$1/$::form{name}/g;
	}
	my $subject = $article::subject_format;
	if ($::form{subject} ne '') {
		$subject =~ s/\$subject/$::form{subject}/g;
	} else {
		$subject =~ s/\$subject/$_no_subject/g;
	}
	$::form{msg}=~s/\x0D\x0A|\x0D|\x0A/\n/g;
	$::form{msg}=~s/^(\s|\n)//g while($::form{msg}=~/^(\s|\n)/);
	$::form{msg}=~s/(\s|\n)$//g while($::form{msg}=~/(\s|\n)$/);
	$::form{msg}=~s/\n/\~\n/g if($article::auto_br);

	my $artic = "$subject\n>$name (@{[&get_now]})~\n~\n$::form{msg}\n";
	$artic .= "\n#comment\n" if ($article::comment);
	my $postdata = '';
	my @postdata_old = split(/\r?\n/, $::database{$::form{'mypage'}});
	my $_article_no = 0;

	foreach (@postdata_old) {
		$postdata .= $_ . "\n" if (!$article::ins);
		if (/^#article/ && (++$_article_no == $::form{article_no})) {
			$postdata .= "$artic\n";
		}
		$postdata .= $_ . "\n" if ($article::ins);
	}
	$::form{mymsg} = $postdata;
	$::form{mytouch} = 'on';
	&do_write("FrozenWrite");
	&close_db;
	exit;
}

sub plugin_article_convert
{
	$article::no++;
	my $conflictchecker = &get_info($::form{mypage}, $::info_ConflictChecker);
	return <<"EOD";
<form action="$::script" method="post">
 <div>
  <input type="hidden" name="article_no" value="$article::no" />
  <input type="hidden" name="cmd" value="article" />
  <input type="hidden" name="mypage" value="$::form{'mypage'}" />
  <input type="hidden" name="myConflictChecker" value="$conflictchecker" />
  <input type="hidden" name="mytouch" value="on" />
  $::resource{article_plugin_name} <input type="text" name="name" size="$article::name_cols" /><br />
  $::resource{article_plugin_subject} <input type="text" name="subject" size="$article::subject_cols" /><br />
  <textarea name="msg" rows="$article::rows" cols="$article::cols"></textarea><br />
  <input type="submit" value="$::resource{article_plugin_btn}" />
 </div>
</form>
EOD
}

1;
