######################################################################
# contents.inc.pl - This is PyukiWiki, yet another Wiki clone.
# contents plugin
#
# $Id: contents.inc.pl,v 1.4 2006/01/09 03:22:32 papu Exp $
#
# PyukiWiki Version 0.1.5a5-pre1
# Copyright (C) 2004 by Nekyo.
# Copyright (C) 2006 PyukiWiki Developers Team
# License: GPL v2 or (at your option) any later version
# http://nekyo.hp.infoseek.co.jp/
# http://pyukiwiki.sourceforge.jp/
#
# Based on YukiWiki <hyuki@hyuki.com> http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
#
# 1TAB=4Spaces
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:UNIX=LF/Windows=CR+LF/Mac=CR
# Japanese Code=EUC
######################################################################
# v0.1.6 2006/01/07 *****ޤб
# v0.0.2 2005/01/20 base ˤб
# v0.0.1 ץȥ
######################################################################

use strict;

sub plugin_contents_convert {
	my ($txt) = $::database{$::form{mypage}};
	my (@txt) = split(/\r?\n/, $txt);
	my $tocnum = 0;
	my (@tocsaved, @tocresult);
	my $title;
	my $nametag = ($::IsMenu == 1) ? "m" : "i";

	foreach (@txt) {
		chomp;
		if (/^(\*{1,5})(.+)/) {
			&back_push('ul', length($1), \@tocsaved, \@tocresult);
			$title = &::inline($2);
			$title =~ s/<[^>]+>//g;
			push(@tocresult, qq(<li><a href="?) . &::encode($::form{mypage})
				. qq(#$nametag$tocnum">$title</a></li>\n));
			$tocnum++;
		}
	}
	push(@tocresult, splice(@tocsaved));
	my $body = <<EOD;
<div class="contents">
<a id="contents_1"></a>
EOD
	$body .= join("\n", @tocresult) . "</div>\n";
	return $body;
}
1;
