######################################################################
# xrea.pl - This is PyukiWiki, yet another Wiki clone.
# xrea plugin for PyukiWiki & YukiWiki
#
# $Id: xrea.pl,v 1.1.1.1 2006/01/07 15:36:28 papu Exp $
#
# PyukiWiki Version 0.1.5a2-pre3
# Copyright (C) 2004 by Nekyo.
# Copyright (C) 2006 PyukiWiki Developers Team
# License: GPL v2 or (at your option) any later version
# http://nekyo.hp.infoseek.co.jp/
# http://pyukiwiki.sourceforge.jp/
#
# Based on YukiWiki <hyuki@hyuki.com> http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
#
# 1TAB=4Spaces
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:UNIX=LF/Windows=CR+LF/Mac=CR
# Japanese Code=EUC
######################################################################
#
# xrea.compLoi[o̓vOC
#
# gp@
#
# index.cgi  index.xcg  gq xcg ɕύX܂B
# (.cgȉꍇ́AL}ɂȂ܂)
# 
# ƎhCݒ肵ĂȂꍇ
# &xrea();
# xrea.com̃T[o[ł΁AIɏo͂܂B
# 
# ƎhCݒ肵Ăꍇ
# ExreaǗʂŁALHTMLmFāA_TuhCmF܂B
# E&xrea(username.s??.xrea.com);
#  xrea.com̃T[o[ł΁AIɏo͂܂B
#
# 
# LʒúAKu1280x1024sNZ̉ʂŌăXN[Kv
# Ȃʒuvɕ\悤ɂĉB
# http://sb.xrea.com/showthread.php?t=10009
#
# ":Header" y[WɓƗǂł傤B
#
# xrea+ALT[o[̏ꍇ́ALo͂svłB
#
######################################################################

use strict;
package xrea;

sub plugin_block {
	return &plugin_inline;
}

sub plugin_inline {
	my $body;
	my $hostname;
	my @args = split(/,/, shift);

	if($args[0] ne '') {
		$hostname=$args[0];
		if($hostname!~/xrea\.com$/) {
			return qq(<strong>xrea.pl error!</strong> '$hostname' not allowed<br />);
		}
		if($ENV{SERVER_ADMIN}!~/xrea\.com$/ || $ENV{SCRIPT_FILENAME}!~/\.xcg$/) {
			return ' ';
		}
	} else {
		$hostname=$ENV{HTTP_HOST};
		if($ENV{SERVER_NAME}!~/xrea\.com$/ || $ENV{SCRIPT_FILENAME}!~/\.xcg$/) {
			return ' ';
		}
	}
	$body=<<EOM;
<script type="text/javascript" src="http://imgj.xrea.com/xa.j?site=$hostname"></script>
<noscript><iframe height="60" width="468" frameborder="0" marginheight="0" marginwidth="0" scrolling="no" allowtransparency="true" src="http://img.xrea.com/ad_iframe.fcg?site=$hostname"><a href="http://img.xrea.com/ad_click.fcg?site=$hostname" target="_blank"><img src="http://img.xrea.com/ad_img.fcg?site=$hostname" border="0" alt="xreaad"></a></iframe></noscript>
EOM
	return $body;
}

sub plugin_usage {
	return {
		name => 'xrea',
		version => '1.0',
		author => 'Nanami <papu@users.sourceforge.jp>',
		syntax => '&xrea(your hostname);',
		description => 'xrea.com AD plugin.',
		example => '&xrea(your hostname);',
	};
}

1;
