######################################################################
# sitemap.pl - This is PyukiWiki, yet another Wiki clone.
# sitemap plugin
#
# $Id: sitemap.inc.pl,v 1.1.1.1 2006/01/07 15:36:28 papu Exp $
#
# PyukiWiki Version 0.1.5a4-pre3
# Copyright (C) 2004 by Nekyo.
# Copyright (C) 2006 PyukiWiki Developers Team
# License: GPL v2 or (at your option) any later version
# http://nekyo.hp.infoseek.co.jp/
# http://pyukiwiki.sourceforge.jp/
#
# Based on YukiWiki <hyuki@hyuki.com> http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
#
# 1TAB=4Spaces
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:UNIX=LF/Windows=CR+LF/Mac=CR
# Japanese Code=EUC
######################################################################
# ȥޥåץץ饰ǤϡŪפ˥桼ʥӥ
# 䤹ץ饰Ǥ
#
# ҤˤϡʲΤ褦ʥ롼뤬ޤ
#
# MenuBarǤϰʲΤ褦˵Ҥ
# ***̾
# [[WikiName]]
# [[ڡ]]
# (WikiNameǤưޤ)
#
# MenuBarϿ줿ڡǤϡʲΤ褦˵Ҥ
# -[[WikiName]] (WikiNameǤưޤ)
# -[[ڡ]]~
# --[[ڡ]]~
# ---[[ڡ]]~
# -[[?cmd=ץ饰&.....]]~
#
# p.s. [[>http://www.yahoo.co.jp/]] 󥯤ϤϤޤ
#
# Ȥ
# ?cmd=sitemap
# http://lineage.netgamers.jp/?cmd=sitemap
#
# ܤwikiΥߤƤ
# http://lineage.netgamers.jp/?cmd=adminedit&mypage=MenuBar
# http://lineage.netgamers.jp/?cmd=adminedit&mypage=%bd%d0%b2%d4%a4%ae%a5%ea%a5%b9%a5%c8
# http://lineage.netgamers.jp/?cmd=edit&mypage=%bd%d0%b2%d4%a4%aeFPK%b9%b6%ce%ac
######################################################################


sub plugin_sitemap_action {
	my $prev = '';
	my $char = '';
	my $idx = 1;
	my $menubar=$::MenuBar;
	my $name;
	my $menucount=0;
	my $submenucount=0;
	my $menu;
	my $basepage;
	my $nextpage;
	my $nestcount=0;
	my $body="*$::resource{sitemap_plugin_title}\n";

	my $bracket_name ='\[\[((?!\[)[^\]]+?)\]\]';
	my $interwiki_name1 = '([^:]+):([^:].*)';
	my $interwiki_name2 = '([^:]+):([^:#].*?)(#.*)?';

	foreach $basepage(split(/\n/,$::database{$menubar})) {
		# MenuBar ***ιܤФ
		if ($basepage=~/^(\*{1,5})(.+)/) {
			$name=$basepage;
			$name=~s/^(\*{1,5})//g;
			$name=&plugin_sitemap_trim($name);
			$menucount++;
			push(@sitemap,$name);
		#  MenuBar֥饱åȤФ
		}elsif($basepage=~/$bracket_name/ && $basepage!~/>(http:|https:|ftp:|mailto:|\?)/
			&& $basepage!~/($interwiki_name1|$interwiki_name2)/) {
			$basepage=~s/$bracket_name/$1/g;
			$basepage=~s/.*>//g if($basepage=~/>/);
			$basepage=&plugin_sitemap_trim($basepage);
			$submenucount++;
			$sitemap{$name}.=sprintf("%05d\t%05d\t%05d\t%s\n",$menucount,$submenucount,0,$basepage);
			$nextmenucount=0;
			# MenuBarФڡ顢٥ΥڡФ


			foreach $subpage(split(/\n/,$::database{$basepage})) {
				if($subpage=~/-{1,3}$bracket_name/ && $subpage!~/>(http:|https:|ftp:|mailto:|\?)/
					&& $subpage!~/($interwiki_name1|$interwiki_name2)/
					|| $subpage=~/>\?cmd=.*/ && $subpage =~ /^-\[\[(.*?)\]\]/) {
					$nextpage=$subpage;
					$nextpage=~s/-{1,3}$bracket_name/$1/g;
					$nextpage=&plugin_sitemap_trim($nextpage);
					$nextpage=~s/.*>//g if($nextpage=~/>/ && $nextpage !~/\?cmd=/);
					$nextmenucount++;
					$sitemap{$name}.=sprintf("%05d\t%05d\t%05d\t%s\n",$menucount,$submenucount,$nextmenucount,$nextpage);
				}
			}
		}
	}
	foreach $menu(@sitemap) {
		if($sitemap{$menu} ne '') {
			$body.="-''$menu''\n";
			foreach(split(/\n/,$sitemap{$menu})) {
				($menucount,$submenucount,$nextmenucount,$page)=split(/\t/,$_);
				$page=~s/[\r|\n]//g;
				if($nextmenucount+0 eq 0) {
					$body.="--[[$page]]\n";
				} else {
					$body.="---[[$page]]\n";
				}
			}
		}
	}
	$body=&text_to_html($body,0);

	return ('msg' => "\t$::resource{sitemap_plugin_title}", 'body' => $body);
}

sub plugin_sitemap_trim {
	my($name)=@_;
	$name=~s/\~//g;
	$name=~s/[\r|\n]//g;
	return $name;
}
1;
